/* CSE303, Spring 2007, Homework 3, Problem 1 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct Point2D {
  double x;
  double y;
};

struct Triangle {
  struct Point2D p1;
  struct Point2D p2;
  struct Point2D p3;
};

struct EquiTriangle {
  struct Point2D origin;
  double angle;
  double length;
};

void initTri(struct Triangle * ans, double x1, double y1, double x2,
	      double y2, double x3, double y3) {
  ans->p1.x = x1;
  ans->p1.y = y1;
  ans->p2.x = x2;
  ans->p2.y = y2;
  ans->p3.x = x3;
  ans->p3.y = y3;
}

void initEqui(struct EquiTriangle * ans, double x, double y, double angle,
	      double length) {
  ans->origin.x = x;
  ans->origin.y = y;
  ans->angle    = angle;
  ans->length   = length;
}

struct Triangle * newShiftedTri1(struct Triangle * tri, 
				 double delta_x, double delta_y) {
  struct Triangle * ans = (struct Triangle*)malloc(sizeof(struct Triangle));
  ans->p1.x = tri->p1.x + delta_x;
  ans->p1.y = tri->p1.y + delta_y;
  ans->p2.x = tri->p2.x + delta_x;
  ans->p2.y = tri->p2.y + delta_y;
  ans->p3.x = tri->p3.x + delta_x;
  ans->p3.y = tri->p3.y + delta_y;
  return ans;
}

int samePoint(struct Point2D p1, struct Point2D p2) {
  return p1.x - p2.x < 1e-10 && p1.x - p2.x > -1e-10
    && p1.y - p2.y < 1e-10 && p1.y - p2.y > -1e-10;
}

// DO NOT CHANGE ANYTHING ABOVE HERE

// ADD YOUR FUNCTIONS HERE

int sameTriangle(struct Triangle * tri1, struct Triangle * tri2) {
  if(samePoint(tri1->p1,tri2->p1))
    return (samePoint(tri1->p2,tri2->p2) && samePoint(tri1->p3,tri2->p3))
      || (samePoint(tri1->p3,tri2->p2) && samePoint(tri1->p2,tri2->p3));

  // ADD CODE HERE

  return 0;
}

// NO NEED TO CHANGE ANYTHING BELOW HERE (except to do different testing
// or to comment out features not yet implemented).

// note there are space leaks in here which is probably okay for testing
void triangle_test() {
  int i, j;
  struct Triangle* triangle_pointers[6];
  for(i=0; i <= 2; ++i)
    triangle_pointers[i] = (struct Triangle*)malloc(sizeof(struct Triangle));
  initTri(triangle_pointers[0], 1.0, 1.0, 3.0, 3.0, 2.0, 4.0);
  initTri(triangle_pointers[1], 1.0, 1.0, 7.0, 7.0, 2.0, 4.0);
  initTri(triangle_pointers[2], 2.0, 4.0, 3.0, 3.0,  1.0, 1.0);
  triangle_pointers[3] = newShiftedTri1(triangle_pointers[0], -2.0, 7.5);
  triangle_pointers[4] = newShiftedTri2(triangle_pointers[1], -2.0, 7.5);
  triangle_pointers[5] = newShiftedTri3(triangle_pointers[2], -2.0, 7.5);
  struct EquiTriangle equi_triangles[3];
  initEqui(&equi_triangles[0], 0, 0,   M_PI/2,   4);
  initEqui(&equi_triangles[1], 0, 4.0, 7*M_PI/6, 4);
  initEqui(&equi_triangles[2], 0, 4.0, 7*M_PI/6, 5);
  for(i=0; i < 6; ++i) 
    printf("triangle %d: (%g,%g) (%g,%g) (%g,%g)\n", i, 
	   triangle_pointers[i]->p1.x, triangle_pointers[i]->p1.y, 
	   triangle_pointers[i]->p2.x, triangle_pointers[i]->p2.y, 
	   triangle_pointers[i]->p3.x, triangle_pointers[i]->p3.y);
  printf("same triangles:\n");
  for(i=0; i < 6; ++i)
    for(j=0; j < 6; ++j)
      if(sameTriangle(triangle_pointers[i],triangle_pointers[j]))
	printf("%d and %d\n",i,j);
  for(i=0; i < 3; ++i) 
    printf("equi triangle %d: (%g,%g) %g %g\n", i,
	   equi_triangles[i].origin.x, equi_triangles[i].origin.y, 
	   equi_triangles[i].angle, equi_triangles[i].length);
  printf("same equi triangles:\n");
  for(i=0; i < 3; ++i) 
    for(j=0; j < 3; ++j) 
      if(sameEqui(&equi_triangles[i],&equi_triangles[j]))
	 printf("%d and %d\n",i,j);
}

int main(int argc, char**argv) {
  triangle_test();
  return 0;
}
